Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_allocation.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_allocation.cpp	(revision 77)
@@ -0,0 +1,124 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+#include "Behavioural/include/Allocation.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::allocation"
+  void Execution_unit_to_Write_unit::allocation (
+#ifdef STATISTICS
+			       morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+			       void
+#endif
+			       )
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+
+    _component   = new Component (_usage);
+
+    Entity * entity = _component->set_entity (_name       
+					      ,"Execution_unit_to_Write_unit"
+#ifdef POSITION
+					      ,COMBINATORY 
+#endif
+					      );
+
+    _interfaces = entity->set_interfaces();
+
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+      Interface * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							 ,IN
+							 ,SOUTH,
+							 "Generalist interface"
+#endif
+							 );
+
+     in_CLOCK        = interface->set_signal_clk              ("clock" ,1, CLOCK_VHDL_YES);
+     in_NRESET       = interface->set_signal_in  <Tcontrol_t> ("nreset",1, RESET_VHDL_YES);
+
+
+    // ~~~~~[ Interface "execute_unit_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+     {
+       ALLOC1_INTERFACE("execute_unit_out", IN, EAST, "Output of execution_unit", _param->_nb_execute_unit);
+
+       ALLOC1_VAL_IN    ( in_EXECUTE_UNIT_OUT_VAL);
+       ALLOC1_ACK_OUT   (out_EXECUTE_UNIT_OUT_ACK);
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_CONTEXT_ID   ,"context_id"   ,Tcontext_t        ,_param->_size_context_id      );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_FRONT_END_ID ,"front_end_id" ,Tcontext_t        ,_param->_size_front_end_id    );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_OOO_ENGINE_ID,"ooo_engine_id",Tcontext_t        ,_param->_size_ooo_engine_id   );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_PACKET_ID    ,"packet_id"    ,Tpacket_t         ,_param->_size_packet_id       );
+     //ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_OPERATION    ,"operation"    ,Toperation_t      ,_param->_size_operation       );
+     //ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_TYPE         ,"type"         ,Ttype_t           ,_param->_size_type            );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_WRITE_RD     ,"write_rd"     ,Tcontrol_t        ,1                             );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_NUM_REG_RD   ,"num_reg_rd"   ,Tgeneral_address_t,_param->_size_general_register);
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_DATA_RD      ,"data_rd"      ,Tgeneral_data_t   ,_param->_size_general_data    );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_WRITE_RE     ,"write_re"     ,Tcontrol_t        ,1                             );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_NUM_REG_RE   ,"num_reg_re"   ,Tspecial_address_t,_param->_size_special_register);
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_DATA_RE      ,"data_re"      ,Tspecial_data_t   ,_param->_size_special_data    );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_EXCEPTION    ,"exception"    ,Texception_t      ,_param->_size_exception       );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_NO_SEQUENCE  ,"no_sequence"  ,Tcontrol_t        ,1                             );
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_UNIT_OUT_ADDRESS      ,"address"      ,Tgeneral_data_t   ,_param->_size_general_data    );
+     }
+    // ~~~~~[ Interface "write_unit_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+     {
+       ALLOC1_INTERFACE("write_unit_in", OUT, WEST, "Input of write_unit", _param->_nb_write_unit);
+
+       ALLOC1_VAL_OUT(out_WRITE_UNIT_IN_VAL);
+       ALLOC1_ACK_IN ( in_WRITE_UNIT_IN_ACK);
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_CONTEXT_ID   ,"context_id"   ,Tcontext_t        ,_param->_size_context_id      );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_FRONT_END_ID ,"front_end_id" ,Tcontext_t        ,_param->_size_front_end_id    );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_OOO_ENGINE_ID,"ooo_engine_id",Tcontext_t        ,_param->_size_ooo_engine_id   );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_PACKET_ID    ,"packet_id"    ,Tpacket_t         ,_param->_size_packet_id       );
+     //ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_OPERATION    ,"operation"    ,Toperation_t      ,_param->_size_operation       );
+     //ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_TYPE         ,"type"         ,Ttype_t           ,_param->_size_type            );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_WRITE_RD     ,"write_rd"     ,Tcontrol_t        ,1                             );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_NUM_REG_RD   ,"num_reg_rd"   ,Tgeneral_address_t,_param->_size_general_register);
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_DATA_RD      ,"data_rd"      ,Tgeneral_data_t   ,_param->_size_general_data    );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_WRITE_RE     ,"write_re"     ,Tcontrol_t        ,1                             );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_NUM_REG_RE   ,"num_reg_re"   ,Tspecial_address_t,_param->_size_special_register);
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_DATA_RE      ,"data_re"      ,Tspecial_data_t   ,_param->_size_special_data    );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_EXCEPTION    ,"exception"    ,Texception_t      ,_param->_size_exception       );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_NO_SEQUENCE  ,"no_sequence"  ,Tcontrol_t        ,1                             );
+       ALLOC1_SIGNAL_OUT(out_WRITE_UNIT_IN_ADDRESS      ,"address"      ,Tgeneral_data_t   ,_param->_size_general_data    );
+     }
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+     _destination = new std::list<uint32_t> * [_param->_nb_execute_unit];
+     for (uint32_t i=0; i<_param->_nb_execute_unit; i++)
+       {
+	 _destination [i] = new std::list<uint32_t> [_param->_nb_thread];
+       }
+
+#ifdef POSITION
+    _component->generate_file();
+#endif
+
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_deallocation.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_deallocation.cpp	(revision 77)
@@ -0,0 +1,88 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::deallocation"
+  void Execution_unit_to_Write_unit::deallocation (void)
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+
+    if (_usage & USE_SYSTEMC)
+      {
+	delete     in_CLOCK ;
+	delete     in_NRESET;
+
+ 	delete []  in_EXECUTE_UNIT_OUT_VAL;
+        delete [] out_EXECUTE_UNIT_OUT_ACK;
+	if (_param->_have_port_context_id)
+        delete []  in_EXECUTE_UNIT_OUT_CONTEXT_ID   ;
+        if (_param->_have_port_front_end_id)
+	delete []  in_EXECUTE_UNIT_OUT_FRONT_END_ID ;
+        if (_param->_have_port_ooo_engine_id)
+	delete []  in_EXECUTE_UNIT_OUT_OOO_ENGINE_ID;
+        if (_param->_have_port_packet_id)
+	delete []  in_EXECUTE_UNIT_OUT_PACKET_ID    ;
+      //delete []  in_EXECUTE_UNIT_OUT_OPERATION    ;
+      //delete []  in_EXECUTE_UNIT_OUT_TYPE         ;
+        delete []  in_EXECUTE_UNIT_OUT_WRITE_RD     ;
+        delete []  in_EXECUTE_UNIT_OUT_NUM_REG_RD   ;
+        delete []  in_EXECUTE_UNIT_OUT_DATA_RD      ;
+        delete []  in_EXECUTE_UNIT_OUT_WRITE_RE     ;
+        delete []  in_EXECUTE_UNIT_OUT_NUM_REG_RE   ;
+        delete []  in_EXECUTE_UNIT_OUT_DATA_RE      ;
+        delete []  in_EXECUTE_UNIT_OUT_EXCEPTION    ;
+        delete []  in_EXECUTE_UNIT_OUT_NO_SEQUENCE  ;
+        delete []  in_EXECUTE_UNIT_OUT_ADDRESS      ;
+
+        delete [] out_WRITE_UNIT_IN_VAL;
+        delete []  in_WRITE_UNIT_IN_ACK;
+        if (_param->_have_port_context_id)
+	delete [] out_WRITE_UNIT_IN_CONTEXT_ID   ;
+        if (_param->_have_port_front_end_id)
+	delete [] out_WRITE_UNIT_IN_FRONT_END_ID ;
+        if (_param->_have_port_ooo_engine_id)
+	delete [] out_WRITE_UNIT_IN_OOO_ENGINE_ID;
+        if (_param->_have_port_packet_id)
+	delete [] out_WRITE_UNIT_IN_PACKET_ID    ;
+      //delete [] out_WRITE_UNIT_IN_OPERATION    ;
+      //delete [] out_WRITE_UNIT_IN_TYPE         ;
+        delete [] out_WRITE_UNIT_IN_WRITE_RD     ;
+        delete [] out_WRITE_UNIT_IN_NUM_REG_RD   ;
+        delete [] out_WRITE_UNIT_IN_DATA_RD      ;
+        delete [] out_WRITE_UNIT_IN_WRITE_RE     ;
+        delete [] out_WRITE_UNIT_IN_NUM_REG_RE   ;
+        delete [] out_WRITE_UNIT_IN_DATA_RE      ;
+        delete [] out_WRITE_UNIT_IN_EXCEPTION    ;
+        delete [] out_WRITE_UNIT_IN_NO_SEQUENCE  ;
+        delete [] out_WRITE_UNIT_IN_ADDRESS      ;
+      }
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    delete [] _destination;
+    delete    _component;
+
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_end_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_end_cycle.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_end_cycle.cpp	(revision 77)
@@ -0,0 +1,47 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::end_cycle"
+void Execution_unit_to_Write_unit::end_cycle ()
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+
+#ifdef STATISTICS
+    _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    _interfaces->testbench();
+#endif
+
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_genMealy.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_genMealy.cpp	(revision 77)
@@ -0,0 +1,109 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::genMealy"
+  void Execution_unit_to_Write_unit::genMealy (void)
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+
+    bool write_unit_use [_param->_nb_write_unit];
+
+    for (uint32_t i=0; i<_param->_nb_write_unit; i++)
+      write_unit_use[i] = (PORT_READ(in_WRITE_UNIT_IN_ACK [i]) == 0);
+
+    for (uint32_t i=0; i<_param->_nb_execute_unit; i++)
+      {
+	bool       ack = false;
+
+	log_printf(TRACE,Execution_unit_to_Write_unit,FUNCTION,"Test execute_unit[%d]",i);
+
+	if (PORT_READ(in_EXECUTE_UNIT_OUT_VAL [i]) == true)
+	  {
+	    log_printf(TRACE,Execution_unit_to_Write_unit,FUNCTION," * have a valid entry.");
+	    
+	    Tcontext_t context_id    = (_param->_have_port_context_id   )?PORT_READ(in_EXECUTE_UNIT_OUT_CONTEXT_ID    [i]):0;
+	    Tcontext_t front_end_id  = (_param->_have_port_front_end_id )?PORT_READ(in_EXECUTE_UNIT_OUT_FRONT_END_ID  [i]):0;
+	    Tcontext_t ooo_engine_id = (_param->_have_port_ooo_engine_id)?PORT_READ(in_EXECUTE_UNIT_OUT_OOO_ENGINE_ID [i]):0;
+	    Tcontext_t num_thread    = get_num_thread(context_id   , _param->_size_context_id   ,
+						      front_end_id , _param->_size_front_end_id ,
+						      ooo_engine_id, _param->_size_ooo_engine_id);
+#ifdef DEBUG_TEST
+	    if (_destination[i][num_thread].empty())
+	      throw ERRORMORPHEO(FUNCTION,"Invalid Operation : They have no write_unit to receive a operation from the execute_unit ["+toString(i)+"], thread ["+toString(num_thread)+"].");
+#endif
+
+	    // find a free write_unit
+	    for (std::list<uint32_t>::iterator it=_destination[i][num_thread].begin();
+		 (it != _destination[i][num_thread].end()) and (ack == false);
+		 it++)
+	      {
+		uint32_t dest = *it;
+
+		log_printf(TRACE,Execution_unit_to_Write_unit,FUNCTION,"   * Test destination [%d].",dest);
+			    
+		if (write_unit_use [dest] == false)
+		  {
+		    log_printf(TRACE,Execution_unit_to_Write_unit,FUNCTION,"     * Is ok! Link.");
+		    // have find !!!
+		    ack                   = true;
+		    write_unit_use [dest] = true;
+
+		    if (_param->_have_port_context_id)
+		    PORT_WRITE(out_WRITE_UNIT_IN_CONTEXT_ID            [dest], PORT_READ(in_EXECUTE_UNIT_OUT_CONTEXT_ID            [i]));
+		    if (_param->_have_port_front_end_id)
+		    PORT_WRITE(out_WRITE_UNIT_IN_FRONT_END_ID          [dest], PORT_READ(in_EXECUTE_UNIT_OUT_FRONT_END_ID          [i]));
+		    if (_param->_have_port_ooo_engine_id)
+		    PORT_WRITE(out_WRITE_UNIT_IN_OOO_ENGINE_ID         [dest], PORT_READ(in_EXECUTE_UNIT_OUT_OOO_ENGINE_ID         [i]));
+		    if (_param->_have_port_packet_id)
+		    PORT_WRITE(out_WRITE_UNIT_IN_PACKET_ID             [dest], PORT_READ(in_EXECUTE_UNIT_OUT_PACKET_ID             [i]));
+		  //PORT_WRITE(out_WRITE_UNIT_IN_OPERATION             [dest], PORT_READ(in_EXECUTE_UNIT_OUT_OPERATION             [i]));
+		  //PORT_WRITE(out_WRITE_UNIT_IN_TYPE                  [dest], PORT_READ(in_EXECUTE_UNIT_OUT_TYPE                  [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_WRITE_RD              [dest], PORT_READ(in_EXECUTE_UNIT_OUT_WRITE_RD              [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_NUM_REG_RD            [dest], PORT_READ(in_EXECUTE_UNIT_OUT_NUM_REG_RD            [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_DATA_RD               [dest], PORT_READ(in_EXECUTE_UNIT_OUT_DATA_RD               [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_WRITE_RE              [dest], PORT_READ(in_EXECUTE_UNIT_OUT_WRITE_RE              [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_NUM_REG_RE            [dest], PORT_READ(in_EXECUTE_UNIT_OUT_NUM_REG_RE            [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_DATA_RE               [dest], PORT_READ(in_EXECUTE_UNIT_OUT_DATA_RE               [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_EXCEPTION             [dest], PORT_READ(in_EXECUTE_UNIT_OUT_EXCEPTION             [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_NO_SEQUENCE           [dest], PORT_READ(in_EXECUTE_UNIT_OUT_NO_SEQUENCE           [i]));
+		    PORT_WRITE(out_WRITE_UNIT_IN_ADDRESS               [dest], PORT_READ(in_EXECUTE_UNIT_OUT_ADDRESS               [i]));
+		  }
+	      }
+	  }
+	PORT_WRITE(out_EXECUTE_UNIT_OUT_ACK [i], ack);
+      }
+
+    for (uint32_t i=0; i<_param->_nb_write_unit; i++)
+      {
+	PORT_WRITE(out_WRITE_UNIT_IN_VAL[i], write_unit_use[i]);  
+      }
+
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_statistics_declaration.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_statistics_declaration.cpp	(revision 77)
@@ -0,0 +1,41 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::statistics_declaration"
+  void Execution_unit_to_Write_unit::statistics_declaration (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Execution_unit_to_Write_unit",
+		      param_statistics);
+    
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_transition.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_transition.cpp	(revision 77)
@@ -0,0 +1,84 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::transition"
+  void Execution_unit_to_Write_unit::transition (void)
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+	// Flush routing_table
+	for (uint32_t i=0; i<_param->_nb_execute_unit; i++)
+	  for (uint32_t j=0; j<_param->_nb_thread; j++)
+	      _destination [i][j].clear();
+	
+	// Fill routing table
+	for (uint32_t i=0; i<_param->_nb_execute_unit; i++)
+	  for (uint32_t j=0; j<_param->_nb_execute_unit; j++)
+	    // Test if link between src and dest
+	    if (_param->_table_routing [i][j])
+	      // Test the thread accepted by the execute_unit
+	      for (uint32_t k=0; k<_param->_nb_thread; k++)
+		if (_param->_table_thread[j][k])
+		  // push_back == minor have a better priority
+		  _destination [i][k].push_back(j);
+      }
+    else
+      {
+	if (_param->_priority == PRIORITY_ROUND_ROBIN)
+	  for (uint32_t i=0; i<_param->_nb_execute_unit; i++)
+	    for (uint32_t j=0; j<_param->_nb_thread; j++)
+	      if (_destination [i][j].size() > 1)
+		{
+		  // Head queue became the Tail queue
+		  _destination [i][j].push_back(_destination [i][j].front());
+		  _destination [i][j].pop_front();
+		}
+      }
+
+
+#if (DEBUG >= DEBUG_TRACE)
+    // Print
+    log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"Routing Table");
+    for (uint32_t i=0; i<_param->_nb_execute_unit; i++)
+      for (uint32_t j=0; j<_param->_nb_thread; j++)
+	for (std::list<uint32_t>::iterator k=_destination[i][j].begin();
+	     k != _destination[i][j].end();
+	     k++)
+	  log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"  * Execute_unit [%d], send at the write_unit [%d], the operation of thread [%d].",i,*k,j);
+#endif
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl.cpp	(revision 77)
@@ -0,0 +1,50 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::vhdl"
+  void Execution_unit_to_Write_unit::vhdl (void)
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl_declaration (vhdl);
+    vhdl_body        (vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl_body.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl_body.cpp	(revision 77)
@@ -0,0 +1,37 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::vhdl_body"
+  void Execution_unit_to_Write_unit::vhdl_body (Vhdl * & vhdl)
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+    vhdl->set_body ("");
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl_declaration.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/src/Execution_unit_to_Write_unit_vhdl_declaration.cpp	(revision 77)
@@ -0,0 +1,36 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace network {
+namespace execution_unit_to_write_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Execution_unit_to_Write_unit::vhdl_declaration"
+  void Execution_unit_to_Write_unit::vhdl_declaration (Vhdl * & vhdl)
+  {
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"Begin");
+    log_printf(FUNC,Execution_unit_to_Write_unit,FUNCTION,"End");
+  };
+
+}; // end namespace execution_unit_to_write_unit
+}; // end namespace network
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
